!INTEGER, PARAMETER:: G_7_COEFFS_LEN = 38 

PURE FUNCTION  CONVERT_COEFFS_FOR_G_7 (A, y1, y2) RESULT(U) 
COMPLEX(DP),INTENT(IN) :: A(0:MAX_COS_ORDER) 
REAL(DP), INTENT(IN) :: y1, y2 
COMPLEX(DP):: U(1: G_7_COEFFS_LEN ) 
REAL(DP):: l, g 

l = y2-y1
g = (1-y2)/l

U(1) = ((-A(3)*7.5E+0_DP*g)-A(3)&
	&*3.75E+0_DP+7.499999999999999E-1_DP*A(2))/l**2
U(2) = (A(3)*7.5E+0_DP*g&
	&+A(3)*3.75E+0_DP-7.499999999999999E-1_DP*A(2))/l**2
U(3) = ((-A(3)*1.6875E+1_DP*g)-A(3)*8.4375E+0_DP&
	&+1.6875E+0_DP*A(2))/l**2
U(4) = ((g*(g*((-A(3)*2.E+1_DP*g)-A(3)*3.E+1_DP&
	&+A(2)*6.E+0_DP)-A(3)*1.2E+1_DP+A(2)*6.E+0_DP-A(1)*2.E+0_DP)-1.E&
	&+0_DP*A(3)+A(2)-A(1)*1.E+0_DP+A(0))*l**2-A(3)*2.0625E+1_DP&
	&*g-A(3)*1.03125E+1_DP+A(2)*2.0625E+0_DP)/l**2
U(5) = (A(3)*5.625E+0_DP*g+2.8125E&
	&+0_DP*A(3)-5.625E-1_DP*A(2))/l**2
U(6) = (1.875E+0_DP*A(3)*g&
	&+9.375E-1_DP*A(3)-1.875E-1_DP*A(2))/l**2
U(7) = ((g*(A(3)*1.5E+1_DP*g+A(3)*1.5E+1_DP-A(2)&
	&*3.E+0_DP)+A(3)*3.E+0_DP-1.4999999999999997E+0_DP*A(2)+5.E-1_DP*A(1))*l&
	&**2+A(3)*3.75E+0_DP)/l**3
U(8) = (1.25E+0_DP*A(3))/l**3
U(9) = -(9.375E-1_DP*A(3))/l**3
U(10) = -(3.125E-1_DP*A(3))/l**3
U(11) = ((g*((-A(3)*1.5E+1_DP*g)-A(3)*1.5E+1_DP&
	&+A(2)*3.E+0_DP)-A(3)*3.E+0_DP+1.4999999999999997E+0_DP*A(2)-5.E-1_DP&
	&*A(1))*l**2-2.8125E+0_DP*A(3))/l**3
U(12) = -(9.375E-1_DP*A(3))/l**3
U(13) = (1.875E+0_DP*A(3))/l**3
U(14) = ((g*(A(3)*1.5E+1_DP*g+A(3)*1.5E+1_DP-A(2)&
	&*3.E+0_DP)+A(3)*3.E+0_DP-1.4999999999999997E+0_DP*A(2)+5.E-1_DP*A(1))*l&
	&**2+A(3)*3.125E+0_DP)/l**3
U(15) = -(9.375E-1_DP*A(3))/l**3
U(16) = -(3.125E-1_DP*A(3))/l**3
U(17) = (A(3)*7.5E+0_DP*g&
	&+A(3)*3.75E+0_DP-7.499999999999999E-1_DP*A(2))/l**2
U(18) = ((-A(3)*7.5E+0_DP*g)-A(3)&
	&*3.75E+0_DP+7.499999999999999E-1_DP*A(2))/l**2
U(19) = (A(3)*5.625E+0_DP*g+2.8125E&
	&+0_DP*A(3)-5.625E-1_DP*A(2))/l**2
U(20) = (1.875E+0_DP*A(3)*g&
	&+9.375E-1_DP*A(3)-1.875E-1_DP*A(2))/l**2
U(21) = ((-1.875E+0_DP*A(3)*g)-9.375E-1_DP&
	&*A(3)+1.875E-1_DP*A(2))/l**2
U(22) = ((-A(3)*5.625E+0_DP*g)-2.8125E+0_DP&
	&*A(3)+5.625E-1_DP*A(2))/l**2
U(23) = -(9.375E-1_DP*A(3))/l**3
U(24) = -(3.125E-1_DP*A(3))/l**3
U(25) = (1.171875E+0_DP*A(3))/l**3
U(26) = (7.8125E-2_DP*A(3))/l**3
U(27) = -(2.34375E-1_DP*A(3))/l**3
U(28) = (2.34375E-1_DP*A(3))/l**3
U(29) = -(9.375E-1_DP*A(3))/l**3
U(30) = -(3.125E-1_DP*A(3))/l**3
U(31) = (4.6875E-1_DP*A(3))/l**3
U(32) = (7.8125E-1_DP*A(3))/l**3
U(33) = ((g*((-A(3)*1.5E+1_DP*g)-A(3)*1.5E+1_DP&
	&+A(2)*3.E+0_DP)-A(3)*3.E+0_DP+1.4999999999999997E+0_DP*A(2)-5.E-1_DP&
	&*A(1))*l**2-2.8125E+0_DP*A(3))/l**3
U(34) = -(9.375E-1_DP*A(3))/l**3
U(35) = -(2.34375E-1_DP*A(3))/l**3
U(36) = (2.34375E-1_DP*A(3))/l**3
U(37) = ((g*(A(3)*1.5E+1_DP*g+A(3)*1.5E+1_DP-A(2)&
	&*3.E+0_DP)+A(3)*3.E+0_DP-1.4999999999999997E+0_DP*A(2)+5.E-1_DP*A(1))*l&
	&**2+A(3)*3.046875E+0_DP)/l**3
U(38) = (7.03125E-1_DP*A(3))/l**3
ENDFUNCTION 


PURE FUNCTION  CALCULATE_ANALYTICALLY_G_7 (S0_X, S0_Y, S0_Z, SC_X, SC_Y, SC_Z, U)& 
			& RESULT(RES) 
REAL(DP), INTENT(IN)::S0_X, S0_Y, S0_Z 
REAL(DP), INTENT(IN)::SC_X(PMAX,2), SC_Y(PMAX,2), SC_Z(PMAX,2) 
COMPLEX(DP),INTENT(IN)::U(1: G_7_COEFFS_LEN ) 
COMPLEX(DP)::RES 
RES = (SC_X(4,2)*SC_Y(4,2)*U(32)+SC_Y(2,2)&
	&*SC_X(4,2)*U(30)+SC_X(3,2)*SC_Y(3,2)*U(22)+SC_Y(1,2)*SC_X(3,2)&
	&*U(20)+SC_X(2,2)*SC_Y(4,2)*U(16)+SC_X(2,2)*SC_Y(2,2)*U(14)+SC_X(1,2)&
	&*SC_Y(3,2)*U(6)+SC_X(1,2)*SC_Y(1,2)*U(4))*S0_z+((SC_Z(3,1)*U(38)+SC_Z(1,1)&
	&*U(37))*S0_x+SC_Z(3,1)*SC_X(4,1)*U(28)+SC_Z(1,1)*SC_X(4,1)&
	&*U(27)+SC_X(2,1)*SC_Z(3,1)*U(12)+SC_Z(1,1)*SC_X(2,1)*U(11))*S0_y&
	&+(SC_Z(3,1)*SC_Y(4,1)*U(36)+SC_Z(1,1)*SC_Y(4,1)*U(35)+SC_Y(2,1)&
	&*SC_Z(3,1)*U(34)+SC_Z(1,1)*SC_Y(2,1)*U(33))*S0_x+SC_Z(2,1)*SC_X(4,2)&
	&*SC_Y(4,2)*U(31)+SC_Z(2,1)*SC_Y(2,2)*SC_X(4,2)*U(29)+SC_Z(3,1)&
	&*SC_X(4,1)*SC_Y(4,1)*U(26)+SC_Z(1,1)*SC_X(4,1)*SC_Y(4,1)*U(25)&
	&+SC_Y(2,1)*SC_Z(3,1)*SC_X(4,1)*U(24)+SC_Z(1,1)*SC_Y(2,1)*SC_X(4,1)&
	&*U(23)+SC_Z(2,1)*SC_X(3,2)*SC_Y(3,2)*U(21)+SC_Y(1,2)*SC_Z(2,1)*SC_X(3,2)&
	&*U(19)+SC_Z(1,1)*SC_X(3,1)*SC_Y(3,1)*U(18)+SC_Y(1,1)*SC_Z(1,1)&
	&*SC_X(3,1)*U(17)+SC_Z(2,1)*SC_X(2,2)*SC_Y(4,2)*U(15)+SC_Z(2,1)&
	&*SC_X(2,2)*SC_Y(2,2)*U(13)+SC_X(2,1)*SC_Z(3,1)*SC_Y(4,1)*U(10)&
	&+SC_Z(1,1)*SC_X(2,1)*SC_Y(4,1)*U(9)+SC_X(2,1)*SC_Y(2,1)*SC_Z(3,1)*U(8)&
	&+SC_Z(1,1)*SC_X(2,1)*SC_Y(2,1)*U(7)+SC_X(1,2)*SC_Z(2,1)*SC_Y(3,2)&
	&*U(5)+SC_X(1,1)*SC_Z(1,1)*U(2)*SC_Y(3,1)+SC_X(1,2)*SC_Y(1,2)*SC_Z(2,1)&
	&*U(3)+U(1)*SC_X(1,1)*SC_Y(1,1)*SC_Z(1,1)
ENDFUNCTION 
